(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

let parse_args () =
  let first_target,mode = if Array.length Sys.argv > 1
  then match Sys.argv.(1) with
    | "-export-make" -> (2,Interface.Export_Make)
    | "-export-script" -> (2,Interface.Export_Script)
    | _ -> (1,Interface.Build)
  else 1,Interface.Build  in
  let targets = ref Rule.TargetSet.empty  in
  for i=first_target to (Array.length Sys.argv - 1) do
    targets := Rule.TargetSet.add Sys.argv.(i) !targets
  done;
  mode, !targets

