(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

exception Action_failed of string
exception Unresolved_promises


type state

val init :
  Oinmfile.flat_scope -> Oinmfile.tree ->
  Hash.Hash_cache.t -> Uptodate.Global_Status.t ->
  Rule.Targets.t ->
  state
  (* The flat_scope is the current oinmfile.
     The tree is the old oinmfile, as far as it has been expanded.
     The targets are the building goals. *)

val run : state ->
  Oinmfile.tree * Uptodate.Global_Status.t * Rulebase.Rulebase.t
  (* The function builds all it can and has to.
     The output tree is the expanded current oinmfile.
     May raise Unresolved_promises (todo) *)

