(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

module type Error_Monad = sig

  include Monad.Monad

  val catch : (unit -> 'a) -> 'a t
  val register : exn -> 'a t
  val handle : 'a t -> 'a
  val to_option : 'a t -> 'a option
  val is_error : 'a t -> bool
  val merge : ('a -> 'b -> 'c) -> 'a t -> 'b t -> 'c t

end

module Id : Error_Monad with type 'a t = 'a
module Deferred_raise : Error_Monad

