(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

let postfix_iter f base targets = ignore (Rulebase.fold_rulebase
  (* All fold data are (). *)
  (fun () -> fun leaf -> (),())
  (fun () -> fun () -> fun leaf -> (),())
  (fun () -> fun target -> fun rule -> Rulebase.Enter ((),(),()))
  (fun () -> fun () -> fun () -> fun target -> fun rule ->
    f rule;
    (),())
  (fun () -> fun () -> fun target -> fun rule -> (),())
  (fun () -> fun () -> fun () -> fun target -> fun rule -> (),())
  base  ()  targets)

let script = postfix_iter (fun rule -> List.iter
  (fun command -> print_string (command ^ "\n"))
  rule.Rule.pre.Rule.actions)

let make = postfix_iter (fun rule ->
  Rule.TargetSet.iter
    (fun drain ->
      print_string (drain ^ ":");
      Rule.TargetSet.iter
        (fun source -> print_string (" " ^ source))
        rule.Rule.pre.Rule.sources;
      print_string "\n";
      List.iter
        (fun action -> print_string ("\t" ^ action ^ "\n"))
        rule.Rule.pre.Rule.actions;
      print_string "\n")
    rule.Rule.drain)

