(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

module Actions : Value_types.Type with type t = string list

val strings_of_actions : Actions.t -> string list
val actions_of_strings : string list -> Actions.t

type execution = Actions.t -> bool
  (* The bool is, whether the execution was successful in terms of exit code. *)

val print_actions : execution
val exec_actions : execution
val prompt_exec_actions : execution

val prompt_exec_read : Actions.t -> string option
  (* Like prompt_exec_actions, but also swallows the process' stdout.
     Unsuccessful execution is indicated by None. *)

