(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

module type Monad_minimal = sig

  type 'a t

  val inj : 'a -> 'a t
  val bind : 'a t -> ('a -> 'b t) -> 'b t

end

module type Monad = sig

  include Monad_minimal

  val map : ('a -> 'b) -> 'a t -> 'b t
  val join : 'a t t -> 'a t

end

module Monad_of_minimal (M:Monad_minimal) : Monad with type 'a t = 'a M.t

module Id : Monad with type 'a t = 'a
module Option : Monad with type 'a t = 'a option

