(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

let buflen = 4096

let exec_read f command =
  let channel = Unix.open_process_in command  in
  let output = f channel  in
  let code = match Unix.close_process_in channel with
  | Unix.WEXITED code -> code  in
  code, output


let string_of_channel inchannel =
  let buf = String.create buflen  in
  let ret = ref ""  in
  let cont = ref true  in
  while !cont do
    let read = input inchannel buf 0 buflen  in
    ret := !ret ^ String.sub buf 0 read;
    cont := read>0
  done;
  !ret

let exec_read_string = exec_read string_of_channel


let lexing_on_channel f c = f (Lexing.from_channel c)

let exec_read_lexing f = exec_read (lexing_on_channel f)

