(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

val string_of_channel : in_channel -> string
  (* Read everything in the channel and concat that to one string. *)

val exec_read : (in_channel -> 'a) -> string -> int * 'a
  (* The given string is a command to be executed.
     The command's stdout is handed to the given funtion.
     The result int is the exit code. *)

val exec_read_lexing : (Lexing.lexbuf -> 'a) -> string -> int * 'a
  (* Specialized version, where the command's stdout is lexed (and usually
     parsed). *)

val exec_read_string : string -> int * string
  (* Specialized version, where the command's stdout is returned as a string. *)

