(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

module Target : Value_types.Type with type t = string

module TargetSet : Value_types.SetT with module Elem=Target
module TargetMap : Value_types.MapT with module Key=Target

module Targets : Value_types.Type with type t = TargetSet.t

type halfrule = { sources:Targets.t; actions:Action.Actions.t }
module Halfrule : Value_types.Type with type t = halfrule

module HalfruleSet : Value_types.SetT with module Elem=Halfrule
module HalfruleMap : Value_types.MapT with module Key=Halfrule

type 'a rule = { pre:halfrule; drain:'a }
module Rule : Value_types.PType with type 'a pt = 'a rule

type 'a drain_cases =
  | Files of Targets.t
  | Scope of 'a
module Drain_cases : Value_types.PType with type 'a pt = 'a drain_cases

val replace_drain : 'a rule -> 'b -> 'b rule

