(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

;;

let mode,targets = Commandline.parse_args ()  in
let cache = Hash.init_cache ()  in
let status = Uptodate.load_global_status ()  in
let oinmfile = Load_oinmfile.load_oinmfile Load_oinmfile.oinmfile_name  in
let old_oinmfile_expanded = Load_oinmfile.load_oinmfile_expanded ()  in

let build_targets = match mode with
| Interface.Build -> targets
| Interface.Export_Make | Interface.Export_Script -> Rule.TargetSet.empty  in
let state = Engine.init
  oinmfile
  old_oinmfile_expanded
  cache
  status
  build_targets  in
let new_oinmfile_expanded,status,rulebase = Engine.run state  in
(match mode with
| Interface.Build -> ()
| Interface.Export_Make -> Export.make rulebase targets
| Interface.Export_Script -> Export.script rulebase targets);

Load_oinmfile.save_oinmfile_expanded new_oinmfile_expanded;
Uptodate.save_global_status status;

