(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

{

open Oinmfile_parser

(*
   This is commented out, because it did not work.
   The idea was, that the subparsers need to work on lexbufs anyway,
   so the best thing is to convert the matched part of the current
   lexbuf into another lexbuf without copying anything around.
   However, the lexbuf used by the lexer is not persistent enough.

let linebuf lexbuf =
  let pos = ref 0  in
  let lexlen = Lexing.lexeme_end lexbuf - Lexing.lexeme_start lexbuf  in
  Lexing.from_function
    (fun s -> fun n ->
    let len = min n (lexlen - !pos)  in
    for i = 0 to len-1 do
      s.[i] <- Lexing.lexeme_char lexbuf (!pos+i)
    done;
    pos := !pos+len;
    len)
*)

}

(*
  Special characters: ' ', \t, #, \n, \\, <, >, {, }, %
*)

let nonspecial = [^' ''\t''#''\n''\\''<''>''{''}''%']
let escaped = '\\'[^'\t']

rule oinmfile = parse
    '\n' { Returntoken }
  | ('#'[^'\n']* | [' ' '\t'])+
         { oinmfile lexbuf }
  | (nonspecial | escaped) (nonspecial | escaped | [' '])*
         { Line (Lexing.lexeme lexbuf) }
  | '<'  { Sourcetoken }
  | '>'  { Draintoken }
  | "{}" { Undonetoken }
  | '{'  { Begintoken }
  | '}'  { Endtoken }
  | "%generated"[' ''\t']
         { Generatedtoken }
  | eof  { EOF }

