(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

let suffix = ".mldeps"

let write_deps name deps =
  let file = open_out name  in
  List.iter
    (fun dep -> output_string file
      (Escape.escape_string Escape.line_escape_spec dep ^ "\n"))
    deps;
  close_out file

let read_deps name =
  let file = open_in name  in
  let deps = ref []  in
  (try
    while true do
      deps := (!deps) @
        [Escape.unescape_string Escape.line_escape_spec (input_line file)]
    done
  with End_of_file -> close_in file);
  !deps

