(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

exception Not_deducible

type filetype = CMI | CMO | CMX | CMA | CMXA | MLDEPS

val has_depsfile : filetype -> bool


type fileinfo

val deduce : string -> fileinfo
  (* The string is the target name.
     May raise Not_deducible. *)

val filetype : fileinfo -> filetype
val base_name : fileinfo -> string
val source_name : fileinfo -> string
val target_name : fileinfo -> string

val kill_suffix : string -> string -> string
  (* kill_suffix (bla^suffix) suffix returns bla.
     Raises Not_found, if the first string does not end with suffix. *)

