(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

{

open Makefile_parser

let spec = Escape.escape_spec '\\'
  [' '; ':'; '#'; '\\']  ['\t','t'; '\n','n']  ['\n']

}

(*
  Special characters: ' ', \t, #, \n, \\, :
*)

let normal_char = [^' ''\t''#''\n''\\'':'] | ('\\'_)

rule makefile = parse
    '\n' { Return }
  | ('#'([^'\n''\\'] | ('\\'_))* | ' ' | "\\\n")+
         { makefile lexbuf }
  | ':'  { Colon }
  | normal_char (normal_char | "\\\n")*
      { Filename (Escape.unescape_lexeme spec lexbuf) }
  | eof  { EOF }


