(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

type mode =
| By_type of Fileinfo.filetype
| Prog
| Prog_inner
| CMA_inner
| CMXA_inner
| Lex
| Yacc

let needs_depsfile mode = match mode with
  | By_type ft -> Fileinfo.has_depsfile ft
  | Prog -> true
  | Prog_inner | CMA_inner | CMXA_inner -> false
  | Lex | Yacc -> false


let table = [
  Prog, "-program";
  Prog_inner, "-program-inner";
  CMA_inner, "-cma-inner";
  CMXA_inner, "-cmxa-inner";
  Lex, "-lex";
  Yacc, "-yacc";
  ]

let mode_to_option mode = List.assoc mode table

let option_to_mode option = try
  Some (fst (List.find (fun (_,name) -> name=option) table))
with
| Not_found -> None

