(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

type options = {
  ocamlc : string;
  ocamlopt : string;
  ocamldep : string;
  used_libs : string;
}

let empty = {
  ocamlc = "";
  ocamlopt = "";
  ocamldep = "";
  used_libs = "";
}

let forward os =
  (if os.ocamlc=""
    then ""
    else " -ocamlc-options " ^ Escape.shell_escape os.ocamlc) ^
  (if os.ocamlopt=""
    then ""
    else " -ocamlopt-options " ^ Escape.shell_escape os.ocamlopt) ^
  (if os.ocamldep=""
    then ""
    else " -ocamldep-options " ^ Escape.shell_escape os.ocamldep) ^
  (if os.used_libs=""
    then ""
    else " -used-libs " ^ Escape.shell_escape os.used_libs)

