(*
   Copyright 2007-2012 by Mark Weyer
   Licensed under the OINM licence version 0
*)

module Hash_Collection : Value_types.Type

module Local_Status : Value_types.Type
  with type t = Hash_Collection.t * Hash_Collection.t
    (* The first collection is for sources, the second for drains. *)

module UDCR : Value_types.Type
  with type t = (Value_types.Unit.t Rule.Drain_cases.pt) Rule.Rule.pt
module UDCR_Map : Value_types.MapT with module Key = UDCR
module Global_Status : Value_types.Type
  with type t = Local_Status.t UDCR_Map.pt

val pre_rule : Hash.Hash_cache.t -> Global_Status.t -> UDCR.t ->
  bool * Hash_Collection.t
    (* The bool is, whether the rule has to be executed.
       The hash collection contains the current hashes of the sources. *)

val post_rule : Hash.Hash_cache.t -> Global_Status.t -> UDCR.t ->
  Hash_Collection.t -> Global_Status.t
    (* The hash collection contains the hashes of the sources
       prior to executing the rule. *)

val save_global_status : Global_Status.t -> unit
val load_global_status : unit -> Global_Status.t

